Index: LMDZ4/trunk/libf/dyn3dpar/ioipsl_stringop.F90
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/ioipsl_stringop.F90	(revision 1146)
+++ LMDZ4/trunk/libf/dyn3dpar/ioipsl_stringop.F90	(revision 1146)
@@ -0,0 +1,256 @@
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Module and routines in this file are taken from IOIPSL
+! files stringop.f90
+! Module names has been changed to avoid problems
+! if compiling model with IOIPSL library
+! Ehouarn - March 2009
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!
+MODULE ioipsl_stringop
+!---------------------------------------------------------------------
+!-
+  INTEGER, DIMENSION(30) :: &
+       & prime=(/1,2,3,5,7,11,13,17,19,23,29,31,37,41,43, &
+       & 47,53,59,61,67,71,73,79,83,89,97,101,103,107,109/)
+!-
+!---------------------------------------------------------------------
+CONTAINS
+!=
+   SUBROUTINE cmpblank (str)
+!---------------------------------------------------------------------
+!-
+!---------------------------------------------------------------------
+   CHARACTER(LEN=*),INTENT(inout) :: str
+!-
+   INTEGER :: lcc,ipb
+!---------------------------------------------------------------------
+   lcc = LEN_TRIM(str)
+   ipb = 1
+   DO
+     IF (ipb >= lcc)   EXIT
+     IF (str(ipb:ipb+1) == '  ') THEN
+       str(ipb+1:) = str(ipb+2:lcc)
+       lcc = lcc-1
+     ELSE
+       ipb = ipb+1
+     ENDIF
+   ENDDO
+!-------------------------
+   END SUBROUTINE cmpblank
+!=
+   INTEGER FUNCTION cntpos (c_c,l_c,c_r,l_r)
+!---------------------------------------------------------------------
+!- Finds number of occurences of c_r in c_c
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   CHARACTER(LEN=*),INTENT(in) :: c_c
+   INTEGER,INTENT(IN) :: l_c
+   CHARACTER(LEN=*),INTENT(in) :: c_r
+   INTEGER,INTENT(IN) :: l_r
+!-
+   INTEGER :: ipos,indx,ires
+!---------------------------------------------------------------------
+   cntpos = 0
+   ipos   = 1
+   DO
+     indx = INDEX(c_c(ipos:l_c),c_r(1:l_r))
+     IF (indx > 0) THEN
+       cntpos = cntpos+1
+       ipos   = ipos+indx+l_r-1
+     ELSE
+       EXIT
+     ENDIF
+   ENDDO
+!---------------------
+   END FUNCTION cntpos
+!=
+   INTEGER FUNCTION findpos (c_c,l_c,c_r,l_r)
+!---------------------------------------------------------------------
+!- Finds position of c_r in c_c
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   CHARACTER(LEN=*),INTENT(in) :: c_c
+   INTEGER,INTENT(IN) :: l_c
+   CHARACTER(LEN=*),INTENT(in) :: c_r
+   INTEGER,INTENT(IN) :: l_r
+!---------------------------------------------------------------------
+    findpos = INDEX(c_c(1:l_c),c_r(1:l_r))
+    IF (findpos == 0)   findpos=-1
+!----------------------
+   END FUNCTION findpos
+!=
+   SUBROUTINE find_str (nb_str,str_tab,str_len_tab,str,pos)
+!---------------------------------------------------------------------
+!- This subroutine looks for a string in a table
+!---------------------------------------------------------------------
+!- INPUT
+!-   nb_str      : length of table
+!-   str_tab     : Table  of strings
+!-   str_len_tab : Table  of string-length
+!-   str         : Target we are looking for
+!- OUTPUT
+!-   pos         : -1 if str not found, else value in the table
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   INTEGER :: nb_str
+   CHARACTER(LEN=*),DIMENSION(nb_str) :: str_tab
+   INTEGER,DIMENSION(nb_str) :: str_len_tab
+   CHARACTER(LEN=*) :: str
+   INTEGER :: pos
+!-
+   INTEGER :: i,il
+!---------------------------------------------------------------------
+   pos = -1
+   il = LEN_TRIM(str)
+   IF ( nb_str > 0 ) THEN
+      DO i=1,nb_str
+         IF (     (INDEX(str_tab(i),str(1:il)) > 0) &
+              .AND.(str_len_tab(i) == il) ) THEN
+            pos = i
+            EXIT
+         ENDIF
+      ENDDO
+   ENDIF
+!-------------------------
+   END SUBROUTINE find_str
+!=
+   SUBROUTINE nocomma (str)
+!---------------------------------------------------------------------
+!-
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   CHARACTER(LEN=*) :: str
+!-
+   INTEGER :: i
+!---------------------------------------------------------------------
+   DO i=1,LEN_TRIM(str)
+     IF (str(i:i) == ',')   str(i:i) = ' '
+   ENDDO
+!------------------------
+   END SUBROUTINE nocomma
+!=
+   SUBROUTINE strlowercase (str)
+!---------------------------------------------------------------------
+!- Converts a string into lowercase
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   CHARACTER(LEN=*) :: str
+!-
+   INTEGER :: i,ic
+!---------------------------------------------------------------------
+   DO i=1,LEN_TRIM(str)
+     ic = IACHAR(str(i:i))
+     IF ( (ic >= 65) .AND. (ic <= 90) )   str(i:i) = ACHAR(ic+32)
+   ENDDO
+!-----------------------------
+   END SUBROUTINE strlowercase
+!=
+   SUBROUTINE struppercase (str)
+!---------------------------------------------------------------------
+!- Converts a string into uppercase
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   CHARACTER(LEN=*) :: str
+!-
+   INTEGER :: i,ic
+!---------------------------------------------------------------------
+   DO i=1,LEN_TRIM(str)
+     ic = IACHAR(str(i:i))
+     IF ( (ic >= 97) .AND. (ic <= 122) )   str(i:i) = ACHAR(ic-32)
+   ENDDO
+!-----------------------------
+   END SUBROUTINE struppercase
+!=
+!------------------
+   SUBROUTINE gensig (str, sig)
+!---------------------------------------------------------------------
+!- Generate a signature from the first 30 characters of the string
+!- This signature is not unique and thus when one looks for the
+!- one needs to also verify the string.
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   CHARACTER(LEN=*) :: str
+   INTEGER          :: sig
+!-
+   INTEGER :: i
+!---------------------------------------------------------------------
+   sig = 0
+   DO i=1,MIN(len_trim(str),30)
+      sig = sig  + prime(i)*IACHAR(str(i:i))
+   ENDDO
+!-----------------------------
+ END SUBROUTINE gensig
+!=
+!------------------
+   SUBROUTINE find_sig (nb_sig, str_tab, str, sig_tab, sig, pos)
+!---------------------------------------------------------------------
+!- Find the string signature in a list of signatures
+!---------------------------------------------------------------------
+!- INPUT
+!-   nb_sig      : length of table of signatures
+!-   str_tab     : Table of strings
+!-   str         : Target string we are looking for 
+!-   sig_tab     : Table of signatures
+!-   sig         : Target signature we are looking for
+!- OUTPUT
+!-   pos         : -1 if str not found, else value in the table
+!---------------------------------------------------------------------
+   IMPLICIT NONE
+!-
+   INTEGER :: nb_sig
+   CHARACTER(LEN=*),DIMENSION(nb_sig) :: str_tab
+   CHARACTER(LEN=*) :: str
+   INTEGER, DIMENSION(nb_sig) :: sig_tab
+   INTEGER :: sig
+!-
+   INTEGER :: pos
+   INTEGER, DIMENSION(nb_sig) :: loczeros
+!-
+   INTEGER :: il, len
+   INTEGER, DIMENSION(1) :: minpos
+!---------------------------------------------------------------------
+!-
+   pos = -1
+   il = LEN_TRIM(str)
+!-
+   IF ( nb_sig > 0 ) THEN
+      !
+      loczeros = ABS(sig_tab(1:nb_sig)-sig)
+      !
+      IF ( COUNT(loczeros < 1) == 1 ) THEN
+         !
+         minpos = MINLOC(loczeros)
+         len = LEN_TRIM(str_tab(minpos(1)))
+         IF ( (INDEX(str_tab(minpos(1)),str(1:il)) > 0) &
+                 .AND.(len == il) ) THEN
+            pos = minpos(1)
+         ENDIF
+         !
+      ELSE IF ( COUNT(loczeros < 1) > 1 ) THEN
+         !
+         DO WHILE (COUNT(loczeros < 1) >= 1 .AND. pos < 0 )
+            minpos = MINLOC(loczeros)
+            len = LEN_TRIM(str_tab(minpos(1)))
+            IF ( (INDEX(str_tab(minpos(1)),str(1:il)) > 0) &
+                 .AND.(len == il) ) THEN
+               pos = minpos(1)
+            ELSE
+               loczeros(minpos(1)) = 99999
+            ENDIF
+         ENDDO
+         !
+      ENDIF
+      !
+   ENDIF
+!-
+ END SUBROUTINE find_sig
+!=
+!------------------
+END MODULE ioipsl_stringop
Index: LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 1122)
+++ LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 1146)
@@ -4,10 +4,6 @@
 c
 c
-#define IO_DEBUG
-
-#undef CPP_IOIPSL
-#define CPP_IOIPSL
-
-      SUBROUTINE leapfrog_p(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+
+      SUBROUTINE leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
      &                    time_0)
 
@@ -21,4 +17,5 @@
        USE vampir
        USE timer_filtre, ONLY : print_filtre_timer
+       USE infotrac
 
       IMPLICIT NONE
@@ -69,13 +66,6 @@
 #include "com_io_dyn.h"
 #include "iniprint.h"
-
-c#include "tracstoke.h"
-
 #include "academic.h"
-!#include "clesphys.h"
-#include "advtrac.h"
       
-      integer nq
-
       INTEGER         longcles
       PARAMETER     ( longcles = 20 )
@@ -88,5 +78,5 @@
       REAL :: vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL :: teta(ip1jmp1,llm)                 ! temperature potentielle 
-      REAL :: q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL :: q(ip1jmp1,llm,nqtot)              ! champs advectes
       REAL :: ps(ip1jmp1)                       ! pression  au sol
       REAL,SAVE :: p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
@@ -109,5 +99,6 @@
 c   tendances dynamiques
       REAL,SAVE :: dv(ip1jm,llm),du(ip1jmp1,llm)
-      REAL,SAVE :: dteta(ip1jmp1,llm),dq(ip1jmp1,llm,nqmx),dp(ip1jmp1)
+      REAL,SAVE :: dteta(ip1jmp1,llm),dp(ip1jmp1)
+      REAL,DIMENSION(:,:,:), ALLOCATABLE, SAVE :: dq
 
 c   tendances de la dissipation
@@ -118,5 +109,6 @@
       REAL,SAVE :: dvfi(ip1jm,llm),dufi(ip1jmp1,llm)
       REAL,SAVE :: dtetafi(ip1jmp1,llm)
-      REAL,SAVE :: dqfi(ip1jmp1,llm,nqmx),dpfi(ip1jmp1)
+      REAL,SAVE :: dpfi(ip1jmp1)
+      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: dqfi
 
 c   variables pour le fichier histoire
@@ -186,5 +178,6 @@
       type(Request) :: Request_physic
       REAL,SAVE :: dvfi_tmp(iip1,llm),dufi_tmp(iip1,llm)
-      REAL,SAVE :: dtetafi_tmp(iip1,llm),dqfi_tmp(iip1,llm,nqmx)
+      REAL,SAVE :: dtetafi_tmp(iip1,llm)
+      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: dqfi_tmp
       REAL,SAVE :: dpfi_tmp(iip1)
 
@@ -195,4 +188,5 @@
       INTEGER :: var_time
       LOGICAL :: ok_start_timer=.FALSE.
+      LOGICAL, SAVE :: firstcall=.TRUE.
 
 c$OMP MASTER
@@ -208,5 +202,5 @@
       itaufin   = nday*day_step
       itaufinp1 = itaufin +1
-
+      modname="leapfrog_p"
 
       itau = 0
@@ -217,4 +211,15 @@
           iday = iday+1
          ENDIF
+
+c Allocate variables depending on dynamic variable nqtot
+c$OMP MASTER
+         IF (firstcall) THEN
+            firstcall=.FALSE.
+            ALLOCATE(dq(ip1jmp1,llm,nqtot))
+            ALLOCATE(dqfi(ip1jmp1,llm,nqtot))
+            ALLOCATE(dqfi_tmp(iip1,llm,nqtot))
+         END IF
+c$OMP END MASTER      
+c$OMP BARRIER
 
 c-----------------------------------------------------------------------
@@ -276,5 +281,5 @@
 c$OMP BARRIER
        else
-          
+! Save fields obtained at previous time step as '...m1'
          ijb=ij_begin
          ije=ij_end
@@ -303,5 +308,5 @@
      .                    llm, -2,2, .TRUE., 1 )
 
-       endif
+       endif ! of if (FirstCaldyn)
        
       forward = .TRUE.
@@ -347,9 +352,9 @@
          IF( MOD(itau,idissip ).EQ.0.AND..NOT.forward ) apdiss = .TRUE.
          IF( MOD(itau,iphysiq ).EQ.0.AND..NOT.forward 
-     s          .and. iflag_phys.NE.0                 ) apphys = .TRUE.
+     s          .and. iflag_phys.EQ.1                 ) apphys = .TRUE.
       ELSE
          IF( MOD(itau   ,iconser) .EQ. 0              ) conser = .TRUE.
          IF( MOD(itau+1,idissip)  .EQ. 0              ) apdiss = .TRUE.
-         IF( MOD(itau+1,iphysiq).EQ.0.AND.iflag_phys.NE.0) apphys=.TRUE.
+         IF( MOD(itau+1,iphysiq).EQ.0.AND.iflag_phys.EQ.1) apphys=.TRUE.
       END IF
 
@@ -455,5 +460,5 @@
      &                                jj_Nb_caldyn,0,0,TestRequest)
  
-        do j=1,nqmx
+        do j=1,nqtot
          call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
      &                                jj_nb_caldyn,0,0,TestRequest)
@@ -490,5 +495,5 @@
        call Register_Hallo(p,ip1jmp1,llmp1,1,1,1,1,TestRequest)
        
-c       do j=1,nqmx
+c       do j=1,nqtot
 c         call Register_Hallo(q(1,1,j),ip1jmp1,llm,1,1,1,1,
 c     *                       TestRequest)
@@ -516,5 +521,5 @@
         call WriteField_p('pkf',reshape(pkf,(/iip1,jmp1,llm/)))
         call WriteField_p('phis',reshape(phis,(/iip1,jmp1/)))
-        do j=1,nqmx
+        do j=1,nqtot
           call WriteField_p('q'//trim(int2str(j)),
      .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
@@ -528,5 +533,7 @@
 
 c$OMP MASTER
-      print*,"Iteration No",True_itau
+      IF (prt_level>9) THEN
+        WRITE(lunout,*)"leapfrog_p: Iteration No",True_itau
+      ENDIF
 
 
@@ -585,7 +592,7 @@
 
 
-         ENDIF
-c
-      ENDIF
+         ENDIF ! of IF (offline)
+c
+      ENDIF ! of IF( forward. OR . leapf )
 cc$OMP END PARALLEL
 
@@ -608,4 +615,5 @@
 c$OMP BARRIER
 !       CALL FTRACE_REGION_BEGIN("integrd")
+
        CALL integrd_p ( 2,vcovm1,ucovm1,tetam1,psm1,massem1 ,
      $         dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis ,
@@ -625,5 +633,5 @@
 c
 c      call WriteField_p('ps',reshape(ps,(/iip1,jmp1/)))
-c      do j=1,nqmx
+c      do j=1,nqtot
 c        call WriteField_p('q'//trim(int2str(j)),
 c     .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
@@ -663,5 +671,7 @@
 c$OMP MASTER
          call suspend_timer(timer_caldyn)
-         print*,'Entree dans la physique : Iteration No ',true_itau
+
+         write(lunout,*)
+     &   'leapfrog_p: Entree dans la physique : Iteration No ',true_itau
 c$OMP END MASTER
 
@@ -669,5 +679,4 @@
 
 c$OMP BARRIER
-
          CALL exner_hyb_p(  ip1jmp1, ps, p,alpha,beta,pks, pk, pkf )
 c$OMP BARRIER
@@ -683,5 +692,4 @@
 c   -----------------------------------------------------
 
-#ifdef CPP_PHYS
 c+jld
 
@@ -689,6 +697,9 @@
       IF (ip_ebil_dyn.ge.1 ) THEN 
           ztit='bil dyn'
-          CALL diagedyn(ztit,2,1,1,dtphys
-     e  , ucov    , vcov , ps, p ,pk , teta , q(:,:,1), q(:,:,2))
+! Ehouarn: be careful, diagedyn is Earth-specific (includes ../phylmd/..)!
+           IF (planet_type.eq."earth") THEN
+            CALL diagedyn(ztit,2,1,1,dtphys
+     &    , ucov    , vcov , ps, p ,pk , teta , q(:,:,1), q(:,:,2))
+           ENDIF
       ENDIF 
 c-jld
@@ -725,5 +736,5 @@
         
 c        call SetDistrib(jj_nb_vanleer)
-        do j=1,nqmx
+        do j=1,nqtot
  
           call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
@@ -756,5 +767,5 @@
 cc$OMP BARRIER
 !        CALL FTRACE_REGION_BEGIN("calfis")
-        CALL calfis_p( nq, lafin ,rdayvrai,time  ,
+        CALL calfis_p(lafin ,rdayvrai,time  ,
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $               du,dv,dteta,dq,
@@ -777,5 +788,5 @@
           dpfi_tmp(1:iip1)     = dpfi(ijb:ijb+iim)  
 c$OMP END MASTER
-        endif
+        endif ! of if ( .not. pole_nord)
 
 c$OMP BARRIER
@@ -799,5 +810,5 @@
      *                      1,0,0,1,Request_physic)
 
-        do j=1,nqmx
+        do j=1,nqtot
           call Register_Hallo(dqfi(1,1,j),ip1jmp1,llm,
      *                        1,0,0,1,Request_physic)
@@ -833,5 +844,5 @@
 c$OMP END MASTER
           
-        endif
+        endif ! of if (.not. pole_nord)
 c$OMP BARRIER
 cc$OMP MASTER        
@@ -842,5 +853,5 @@
 cc$OMP END MASTER
 c      
-c      do j=1,nqmx
+c      do j=1,nqtot
 c        call WriteField_p('dqfi'//trim(int2str(j)),
 c     .                reshape(dqfi(:,:,j),(/iip1,jmp1,llm/)))
@@ -853,5 +864,5 @@
          ENDIF
        
-          CALL addfi_p( nqmx, dtphys, leapf, forward   ,
+          CALL addfi_p( dtphys, leapf, forward   ,
      $                  ucov, vcov, teta , q   ,ps ,
      $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
@@ -889,5 +900,5 @@
      *                               jj_Nb_caldyn,Request_physic)
 
-        do j=1,nqmx
+        do j=1,nqtot
         
           call Register_SwapField(q(1,1,j),q(1,1,j),ip1jmp1,llm,
@@ -922,6 +933,16 @@
 cc$OMP END MASTER
 
-#else
-
+
+c-jld
+c$OMP MASTER
+         call resume_timer(timer_caldyn)
+         if (FirstPhysic) then
+           ok_start_timer=.TRUE.
+           FirstPhysic=.false.
+         endif
+c$OMP END MASTER
+       ENDIF ! of IF( apphys )
+
+      IF(iflag_phys.EQ.2) THEN ! "Newtonian" case
 c   Calcul academique de la physique = Rappel Newtonien + fritcion 
 c   --------------------------------------------------------------
@@ -939,21 +960,9 @@
 
        call friction_p(ucov,vcov,iphysiq*dtvr)
-
-#endif
-
-c-jld
-c$OMP MASTER
-         call resume_timer(timer_caldyn)
-         if (FirstPhysic) then
-           ok_start_timer=.TRUE.
-           FirstPhysic=.false.
-         endif
-c$OMP END MASTER
-       ENDIF
+      ENDIF ! of IF(iflag_phys.EQ.2)
+
 
         CALL pression_p ( ip1jmp1, ap, bp, ps, p                  )
 c$OMP BARRIER
-
-
         CALL exner_hyb_p( ip1jmp1, ps, p,alpha,beta, pks, pk, pkf )
 c$OMP BARRIER
@@ -1285,4 +1294,5 @@
                ENDIF
 #ifdef CPP_IOIPSL
+             IF (ok_dynzon) THEN 
              call Register_Hallo(vcov,ip1jm,llm,1,0,0,1,TestRequest)
              call SendRequest(TestRequest)
@@ -1291,8 +1301,12 @@
 c$OMP BARRIER
 c$OMP MASTER
-              CALL writedynav_p(histaveid, nqmx, itau,vcov ,
+              CALL writedynav_p(histaveid, itau,vcov ,
      ,                          ucov,teta,pk,phi,q,masse,ps,phis)
-c$OMP END MASTER
-
+
+c ATTENTION!!! bilan_dyn_p ne marche probablement pas avec OpenMP
+              CALL bilan_dyn_p(2,dtvr*iperiod,dtvr*day_step*periodav, 
+     ,             ps,masse,pk,pbaru,pbarv,teta,phi,ucov,vcov,q) 
+c$OMP END MASTER
+              ENDIF !ok_dynzon
 #endif
             ENDIF
@@ -1304,45 +1318,59 @@
 c      IF( MOD(itau,iecri         ).EQ.0) THEN
 
-           IF( MOD(itau,iecri*day_step).EQ.0) THEN
-c$OMP BARRIER
-c$OMP MASTER
-               nbetat = nbetatdem
-        CALL geopot_p  ( ip1jmp1, teta  , pk , pks,  phis  , phi )
+            IF( MOD(itau,iecri*day_step).EQ.0) THEN
+c$OMP BARRIER
+c$OMP MASTER
+              nbetat = nbetatdem
+              CALL geopot_p(ip1jmp1,teta,pk,pks,phis,phi)
        
 cym        unat=0.
         
-        ijb=ij_begin
-        ije=ij_end
-        
-        if (pole_nord) then
-          ijb=ij_begin+iip1
-          unat(1:iip1,:)=0.
-        endif
-        
-        if (pole_sud) then 
-          ije=ij_end-iip1
-          unat(ij_end-iip1+1:ij_end,:)=0.
-        endif
+              ijb=ij_begin
+              ije=ij_end
+        
+              if (pole_nord) then
+                ijb=ij_begin+iip1
+                unat(1:iip1,:)=0.
+              endif
+        
+              if (pole_sud) then 
+                ije=ij_end-iip1
+                unat(ij_end-iip1+1:ij_end,:)=0.
+              endif
             
-        do l=1,llm
-           unat(ijb:ije,l)=ucov(ijb:ije,l)/cu(ijb:ije)
-        enddo
-
-        ijb=ij_begin
-        ije=ij_end
-        if (pole_sud) ije=ij_end-iip1
-        
-        do l=1,llm
-           vnat(ijb:ije,l)=vcov(ijb:ije,l)/cv(ijb:ije)
-        enddo
+              do l=1,llm
+                unat(ijb:ije,l)=ucov(ijb:ije,l)/cu(ijb:ije)
+              enddo
+
+              ijb=ij_begin
+              ije=ij_end
+              if (pole_sud) ije=ij_end-iip1
+        
+              do l=1,llm
+                vnat(ijb:ije,l)=vcov(ijb:ije,l)/cv(ijb:ije)
+              enddo
         
 #ifdef CPP_IOIPSL
  
-        CALL writehist_p(histid,histvid, nqmx,itau,vcov, 
-     s                       ucov,teta,phi,q,masse,ps,phis)
+              CALL writehist_p(histid,histvid, itau,vcov, 
+     &                         ucov,teta,phi,q,masse,ps,phis)
 
 #endif
-c$OMP END MASTER
-           ENDIF
+! For some Grads outputs of fields
+              if (output_grads_dyn) then
+! Ehouarn: hope this works the way I think it does:
+                  call Gather_Field(unat,ip1jmp1,llm,0)
+                  call Gather_Field(vnat,ip1jm,llm,0)
+                  call Gather_Field(teta,ip1jmp1,llm,0)
+                  call Gather_Field(ps,ip1jmp1,1,0)
+                  do iq=1,nqtot
+                    call Gather_Field(q(1,1,iq),ip1jmp1,llm,0)
+                  enddo
+                  if (mpi_rank==0) then
+#include "write_grads_dyn.h"
+                  endif
+              endif ! of if (output_grads_dyn)
+c$OMP END MASTER
+            ENDIF ! of IF(MOD(itau,iecri).EQ.0)
 
             IF(itau.EQ.itaufin) THEN
@@ -1351,13 +1379,16 @@
 c$OMP MASTER
 
-c#ifdef CPP_IOIPSL
-
-       CALL dynredem1_p("restart.nc",0.0,
-     ,                     vcov,ucov,teta,q,nqmx,masse,ps)
-c#endif
+              if (planet_type.eq."earth") then
+#ifdef CPP_EARTH
+! Write an Earth-format restart file
+                CALL dynredem1_p("restart.nc",0.0,
+     &                           vcov,ucov,teta,q,masse,ps)
+
+#endif
+              endif ! of if (planet_type.eq."earth")
 
               CLOSE(99)
 c$OMP END MASTER
-            ENDIF
+            ENDIF ! of IF (itau.EQ.itaufin)
 
 c-----------------------------------------------------------------------
@@ -1390,7 +1421,9 @@
                  dt  = 2.*dtvr
                  GO TO 2
-            END IF
-
-      ELSE
+            END IF ! of IF (MOD(itau,iperiod).EQ.0)
+                   !    ELSEIF (MOD(itau-1,iperiod).EQ.0)
+
+
+      ELSE ! of IF (.not.purmats)
 
 c       ........................................................
@@ -1419,7 +1452,7 @@
                GO TO 2
 
-            ELSE
-
-            IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
+            ELSE ! of IF(forward)
+
+              IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
                IF(itau.EQ.itaufin) THEN
                   iav=1
@@ -1428,20 +1461,23 @@
                ENDIF
 #ifdef CPP_IOIPSL
-c$OMP BARRIER
-
-              call Register_Hallo(vcov,ip1jm,llm,1,0,0,1,TestRequest)
-              call SendRequest(TestRequest)
-c$OMP BARRIER
-              call WaitRequest(TestRequest)
-
-c$OMP BARRIER
-c$OMP MASTER
-              CALL writedynav_p(histaveid, nqmx, itau,vcov ,
+               IF (ok_dynzon) THEN
+c$OMP BARRIER
+
+               call Register_Hallo(vcov,ip1jm,llm,1,0,0,1,TestRequest)
+               call SendRequest(TestRequest)
+c$OMP BARRIER
+               call WaitRequest(TestRequest)
+
+c$OMP BARRIER
+c$OMP MASTER
+               CALL writedynav_p(histaveid, itau,vcov ,
      ,                          ucov,teta,pk,phi,q,masse,ps,phis)
-               call bilan_dyn_p (2,dtvr*iperiod,dtvr*day_step*periodav,
+               CALL bilan_dyn_p(2,dtvr*iperiod,dtvr*day_step*periodav,
      ,           ps,masse,pk,pbaru,pbarv,teta,phi,ucov,vcov,q)
 c$OMP END MASTER
+               END IF !ok_dynzon
 #endif
-            ENDIF
+              ENDIF ! of IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin)
+
 
 c               IF(MOD(itau,iecri         ).EQ.0) THEN
@@ -1449,69 +1485,76 @@
 c$OMP BARRIER
 c$OMP MASTER
-                  nbetat = nbetatdem
-       CALL geopot_p( ip1jmp1, teta  , pk , pks,  phis  , phi   )
+                nbetat = nbetatdem
+                CALL geopot_p(ip1jmp1,teta,pk,pks,phis,phi)
 
 cym        unat=0.
-        ijb=ij_begin
-        ije=ij_end
-        
-        if (pole_nord) then
-          ijb=ij_begin+iip1
-          unat(1:iip1,:)=0.
-        endif
-        
-        if (pole_sud) then 
-          ije=ij_end-iip1
-          unat(ij_end-iip1+1:ij_end,:)=0.
-        endif
+                ijb=ij_begin
+                ije=ij_end
+        
+                if (pole_nord) then
+                  ijb=ij_begin+iip1
+                  unat(1:iip1,:)=0.
+                endif
+        
+                if (pole_sud) then 
+                  ije=ij_end-iip1
+                  unat(ij_end-iip1+1:ij_end,:)=0.
+                endif
             
-        do l=1,llm
-           unat(ijb:ije,l)=ucov(ijb:ije,l)/cu(ijb:ije)
-        enddo
-
-        ijb=ij_begin
-        ije=ij_end
-        if (pole_sud) ije=ij_end-iip1
-        
-        do l=1,llm
-           vnat(ijb:ije,l)=vcov(ijb:ije,l)/cv(ijb:ije)
-        enddo
+                do l=1,llm
+                  unat(ijb:ije,l)=ucov(ijb:ije,l)/cu(ijb:ije)
+                enddo
+
+                ijb=ij_begin
+                ije=ij_end
+                if (pole_sud) ije=ij_end-iip1
+        
+                do l=1,llm
+                  vnat(ijb:ije,l)=vcov(ijb:ije,l)/cv(ijb:ije)
+                enddo
 
 #ifdef CPP_IOIPSL
 
-       CALL writehist_p( histid, histvid, nqmx, itau,vcov , 
-     ,                           ucov,teta,phi,q,masse,ps,phis)
-c#else
-c      call Gather_Field(unat,ip1jmp1,llm,0)
-c      call Gather_Field(vnat,ip1jm,llm,0)
-c      call Gather_Field(teta,ip1jmp1,llm,0)
-c      call Gather_Field(ps,ip1jmp1,1,0)
-c      do iq=1,nqmx
-c        call Gather_Field(q(1,1,iq),ip1jmp1,llm,0)
-c      enddo
+                CALL writehist_p(histid, histvid, itau,vcov , 
+     &                           ucov,teta,phi,q,masse,ps,phis)
+#endif
+! For some Grads output (but does it work?)
+                if (output_grads_dyn) then
+                  call Gather_Field(unat,ip1jmp1,llm,0)
+                  call Gather_Field(vnat,ip1jm,llm,0)
+                  call Gather_Field(teta,ip1jmp1,llm,0)
+                  call Gather_Field(ps,ip1jmp1,1,0)
+                  do iq=1,nqtot
+                    call Gather_Field(q(1,1,iq),ip1jmp1,llm,0)
+                  enddo
 c      
-c      if (mpi_rank==0) then
-c#include "write_grads_dyn.h"
-c      endif
+                  if (mpi_rank==0) then
+#include "write_grads_dyn.h"
+                  endif
+                endif ! of if (output_grads_dyn)
+
+c$OMP END MASTER
+              ENDIF ! of IF(MOD(itau,iecri*day_step).EQ.0)
+
+              IF(itau.EQ.itaufin) THEN
+                if (planet_type.eq."earth") then
+#ifdef CPP_EARTH
+c$OMP MASTER
+                   CALL dynredem1_p("restart.nc",0.0,
+     .                               vcov,ucov,teta,q,masse,ps)
+c$OMP END MASTER
 #endif
-
-c$OMP END MASTER
-               ENDIF
-
-                 IF(itau.EQ.itaufin) THEN
-c$OMP MASTER
-                   CALL dynredem1_p("restart.nc",0.0,
-     .                               vcov,ucov,teta,q,nqmx,masse,ps)
-c$OMP END MASTER
-                 ENDIF
-                 forward = .TRUE.
-                 GO TO  1
-
-            ENDIF
-
-      END IF
-c$OMP MASTER
-        call finalize_parallel
-c$OMP END MASTER
-        RETURN
+                endif ! of if (planet_type.eq."earth")
+              ENDIF ! of IF(itau.EQ.itaufin)
+
+              forward = .TRUE.
+              GO TO  1
+
+            ENDIF ! of IF (forward)
+
+      END IF ! of IF(.not.purmats)
+c$OMP MASTER
+      call finalize_parallel
+c$OMP END MASTER
+      RETURN
       END
Index: LMDZ4/trunk/libf/dyn3dpar/parallel.F90
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/parallel.F90	(revision 1122)
+++ LMDZ4/trunk/libf/dyn3dpar/parallel.F90	(revision 1146)
@@ -51,4 +51,11 @@
 #else
        using_mpi=.FALSE.
+#endif
+      
+
+#ifdef CPP_OMP
+       using_OMP=.TRUE.
+#else
+       using_OMP=.FALSE.
 #endif
       
Index: LMDZ4/trunk/libf/dyn3dpar/qminimum_p.F
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/qminimum_p.F	(revision 1122)
+++ LMDZ4/trunk/libf/dyn3dpar/qminimum_p.F	(revision 1146)
@@ -50,7 +50,8 @@
       DO 1000 k = 1, llm
       DO 1040 i = ijb, ije
-            zx_defau      = AMAX1( seuil_liq - q(i,k,iq_liq), 0.0 )
-            q(i,k,iq_vap) = q(i,k,iq_vap) - zx_defau
-            q(i,k,iq_liq) = q(i,k,iq_liq) + zx_defau
+            if (seuil_liq - q(i,k,iq_liq) .gt. 0.d0 ) then
+               q(i,k,iq_vap) = q(i,k,iq_vap) + q(i,k,iq_liq) - seuil_liq
+               q(i,k,iq_liq) = seuil_liq
+            endif
  1040 CONTINUE
  1000 CONTINUE
@@ -69,8 +70,9 @@
 c$OMP DO SCHEDULE(STATIC)
       DO i = ijb, ije
-         zx_abc = deltap(i,k)/deltap(i,k-1)
-         zx_defau    = AMAX1( seuil_vap - q(i,k,iq), 0.0 )
-         q(i,k-1,iq) =  q(i,k-1,iq) - zx_defau * zx_abc
-         q(i,k,iq)   =  q(i,k,iq)   + zx_defau  
+         if ( seuil_vap - q(i,k,iq) .gt. 0.d0 ) then
+            q(i,k-1,iq) =  q(i,k-1,iq) - ( seuil_vap - q(i,k,iq) ) *
+     &           deltap(i,k) / deltap(i,k-1)
+            q(i,k,iq)   =  seuil_vap  
+         endif
       ENDDO
 c$OMP END DO NOWAIT
